package eu.diva.tis.thinkingtool.resource;


import eu.diva.tis.api.domain.Alert;
import eu.diva.tis.api.domain.AlertDetails;
import eu.diva.tis.api.domain.AlertType;
import eu.diva.tis.api.domain.ResourceNeed;
import eu.diva.tis.api.domain.ResourceType;
import eu.diva.tis.api.domain.Task;

public class ObjectFactory
{
    public static <T> Object createObject( Class< T > clazz )
    {
        if( clazz == Alert.class )
        {
            return createAlert();
        }
        else if( clazz == AlertDetails.class )
        {
            return createAlertDetails();
        }
        else if( clazz == ResourceNeed.class )
        {
            return createResourceNeed();
        }
        else if( clazz == Task.class )
        {
            return createTask();
        }
        else
        {
            throw new RuntimeException("Unsupported object type: " + clazz.getName() );
        }
    }

    private static Task createTask()
    {
        final Task task = new Task();
        task.setId( 123456 );
        final ResourceNeed desc1 = new ResourceNeed();
        desc1.setQuantity( 1 );
        desc1.setType( ResourceType.AMBULANCE );
        task.getResourceNeeds().add( desc1 );
        final ResourceNeed desc2 = new ResourceNeed();
        desc2.setQuantity( 10 );
        desc2.setType( ResourceType.MEDICAL_WORKER );
        task.getResourceNeeds().add( desc2 );
        return task;
    }

    private static ResourceNeed createResourceNeed()
    {
        final ResourceNeed desc = new ResourceNeed();
        desc.setQuantity( 10 );
        desc.setType( ResourceType.MEDICAL_WORKER );
        return desc;
    }

    private static Alert createAlert()
    {
        final Alert alert = new Alert();
        alert.setEmitter( "Sample Emitter" );
        alert.setId( 123456 );
        alert.setTitle( "Sample alert" );
        alert.setType( AlertType.FIRE );
        final AlertDetails details = createAlertDetails();
        alert.setDetails( details );
        return alert;
    }

    private static AlertDetails createAlertDetails()
    {
        final AlertDetails details = new AlertDetails();
        details.setContactName( "Sample contact" );
        details.setContactPhone( "1122334455" );
        details.setDescription( "Sample description" );
        details.setGpsCoordinates( "+41.23N -32.53W" );
        return details;
    }
    
    
}
